/*****************************************************************/
/* JS/CSS file 'ctl.js' for SeeDeClip4 DMS                        */
/*    Copyright (c) 2016 Cutestudio Ltd., All Rights Reserved.   */
/*****************************************************************/

var pageargs = [];
var postargs = [];
var ctl_starttime = 0;

//** Ask the program to give us something to draw/call etc.
var maxflying = 5;
var numflying = 0;
var sconns = [];

//** Send an ajax request
function ajax_request(url, query, reply, is_post)
{
 var type = (is_post) ? 'POST' : 'GET';
 if (!is_post && query && query.length)
 {

  if (url.indexOf('?') < 0)
   url += '?';
  else if (url.indexOf('=') >= 0)
   url += '&';

  url += query;
 }

 var conn = (sconns.length) ? sconns.pop() : new XMLHttpRequest();
 conn.open(type, url, true);
 conn.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
 conn.onreadystatechange = reply;

 if (is_post)
  conn.send(query);
 else
  conn.send();

 numflying++;

 return conn;
}

//** If running flascontrol plugin this is needed
function FlashControl(action) { }

//** Enabled?
function set_enabled(id, enabled)
{
 var o = document.getElementById(id);
 if (o && (o.disabled != !enabled))
  o.disabled = !enabled;
}

//** Checked?
function set_checked(id, checked)
{
 var o = document.getElementById(id);
 if (o && (!o.checked != !checked))
  o.checked = (checked) ? true : false;
}
function is_checked(id)
{
 var o = document.getElementById(id);
 return o && o.checked;
}

//** Set width
function set_width_of(id, n)
{
 var o = document.getElementById(id);
 var txt = (n >= 0) ? n + 'px' : 'auto';
 if (o && (o.style.width != txt))
  o.style.width = txt;
}

function set_height_of(id, n)
{
 var o = document.getElementById(id);
 var txt = (n >= 0) ? n + 'px' : 'auto';
 if (o && (o.style.height != txt))
  o.style.height = txt;
}

function set_left_pos(id, n)
{
 var o = document.getElementById(id);
 var txt = n +"px";
 if (o && (o.style.left != txt))
  o.style.left = txt;
}

function set_top_pos(id, n)
{
 var o = document.getElementById(id);
 var txt = n +"px";
 if (o && (o.style.top != txt))
  o.style.top = txt;
}

//** Width of an element
function width_of(id)
{
 var o = document.getElementById(id);
 return (o) ? o.offsetWidth : 0;
}

//** Height of an element
function height_of(id)
{
 var o = document.getElementById(id);
 return (o) ? o.offsetHeight : 0;
}

//** Copy width from one element to another
function widthcpy(to, from)
{
 set_width_of(to, width_of(from));
}

//** Copy height from one element to another
function heightcpy(to, from)
{
 set_height_of(to, height_of(from));
}

//** Visibility of a div
function set_visible_obj(o, vis)
{
 if (o)
 {
  var v = (vis) ? 'visible' : 'hidden';
  o.style.visibility = v;
 }
}

//** Visibility of a div
function set_visible_of(id, vis)
{
 var o = document.getElementById(id);
 if (o)
  set_visible_obj(o, vis);

 return o;
}

//** backgrounds
var background_img = null;
function set_div_background(o, src)
{
 if (o)
 {
  if(src)
  {
   if (!background_img)
    background_img = new Image();
   background_img.src = src;

   o.style.backgroundImage = 'url("' + src + '")';
   o.style.backgroundSize = '100%';
  }
  else
   o.style.backgroundImage = null;
 }
}

//** Set the class by 'id'
function set_class_of(id, classname)
{
 var o = document.getElementById(id);
 if (o && (o.className != classname))
  o.className = classname;
}

//** Set the class modifier
function set_class_mod(o, mod)
{
 if (o)
 {
  var c = o.className;
  var c = c.replace(/_[posnr]$/g, "");
  var newName = c + mod;
  if (o.className != newName)
   o.className = newName;
 }
}

//** Set the class modifier
function set_class_of_mod(id, mod)
{
 var o = document.getElementById(id);
 if (o)
  set_class_mod(o, mod)
}

//** Set the title by 'id'
function set_title_of(id, title)
{
 var o = document.getElementById(id);
 if (o && (o.title != title))
  o.title = title;
}

function first_caps(name)
{

 if ((name.search(/[a-z]/) == -1) && (name.length > 5))
  name = name.toLowerCase();

 var words = name.split(' ');
 var newer = [];
 for (var i=0; i<words.length; i++)
 {
  var word = words[i];
  newer[newer.length] = word.charAt(0).toUpperCase() + word.slice(1);
 }
 name = newer.join(" ");

 return name;
}

//** Menu name - spaces to LF
function menu_name(name)
{
 name = name.replace(/[_\-:]/gm, " ");
 name = first_caps(name);
 name = name.replace(/ /gm, "<br/>");
 return name;
}

var last_alert_string=null;

function reset_last_alert_string()
{
 last_alert_string = null;
}

var ctl_timeouts = [];
function ctl_setTimeout(target, ms, desc)
{
 if (ctl_timeouts[desc])
  ctl_timeouts[desc] = ctl_timeouts[desc] + 1;
 else
  ctl_timeouts[desc] = 1;

 return setTimeout(target, ms);
}

//** process the reply from the program
var json_data = null;
function process_reply_text(txt)
{

 var id = null, value = null;
 var data = txt.split('::::');
 for (var i=0; i<data.length; i+=2)
 {
   if ((i + 2) <= data.length)
  {
   id = data[i].replace(/[\r\n]/gm,"");
   value = data[i+1];

   if (id == 'eval')
    eval(value);
   else if (id == 'query')
    process_query(value);
   else if ((id == 'alert') || (id == 'error'))
   {
    if (!value.length)
     value = null;
    if (value != last_alert_string)
    {
     last_alert_string = value;
     message_set("alert", value, 5);
     if (value)
      ctl_setTimeout("reset_last_alert_string()", 5000, "rst_alert");
    }
   }
   else if (id == 'canvas')
    canvas_draw(value);
   else if (id == 'json')
    json_data = JSON.parse(value);
   else
   {
    var o = document.getElementById(id);
    if (o && (o.innerHTML != value))
     o.innerHTML = value;
   }
  }
 }
 id = null;
 value = null;
 data = null;;
}

//** Add on args for this page
function add_on_args(args)
{
 var query = '';

 for (var key in args)
 {
  var value = args[key];
  if (value)
   query += '&' + key + '=' + encodeURIComponent(value);
 }

 return query;
}

//** Exec it.
function exec_query(query)
{
 var page = null;
 var is_post = false;

 if (query.indexOf('?') < 0)
 {
  page = query;
  query = '';
 }
 else
 {
  var auq = query.split('?');
  page = auq.shift();
  is_post = (auq[0].indexOf('method=set') >= 0) || (auq[0].indexOf('post=1') >= 0);
  query = auq.join('?') + '&';
 }

 query += 'lists=' + control_list_cache;

 query += add_on_args(pageargs);
 if (is_post)
  query += add_on_args(postargs);

 ajax_request(page, query, process_query_reply, is_post);
}

//** True if it's in there
function ctl_in_array(arr, item)
{
 if (item && arr)
  return arr.indexOf(item);
 else
  return -1;
}

//** Defer the query as Chrome gets too busy
var qdefer = Array();
function defer_checker(qnew)
{

 if (qnew)
 {
  if (ctl_in_array(qdefer, qnew) < 0)
   qdefer.unshift(qnew);
 }
 else
 {
  while (qdefer.length && (numflying < maxflying))
  {
   var query = qdefer.pop();
   exec_query(query);
  }
 }

}

//** Defer the query by sticking it into a queue.
function defer_query(query)
{
 if (qdefer.length < 150)
  defer_checker(query);
 else
  defer_checker(null);
}

//** Send or queue an ajax query
function process_query(query)
{

 if (numflying >= maxflying)
  defer_query(query);
 else
  exec_query(query);
}

//** Return a random bit of query to avoid browser caching.
//** The time is actually the best here, guaranteed good.
function random_query_element()
{
 var d = new Date();
 return "&rand=" + d.getTime();
}

//** All settings replies come here
function process_query_reply(event)
{
 var conn = event.target;

 if (conn.readyState == 4)
 {
  process_reply_text(conn.responseText);
  conn.onreadystatechange = null;
  conn.abort = null;
  conn = null;
  event = null;

  numflying --;
 }

 if ((numflying < maxflying) && qdefer.length)
  ctl_setTimeout("defer_checker(null)", 50, "defer");
}

//** setting from JS objects
var control_list = [];
var control_list_cache = "";

function control_set(query)
{
 process_query('control.ctl?method=set&' + query);
}

//** setting from JS objects
function ctl_set_exact(e, id, value)
{
 if (e)
  noprop(e);
 control_set(id + '=' + encodeURIComponent(value));
}

//** setting from JS objects
function ctl_set(e, id)
{
 if (e)
  noprop(e);
 var o = document.getElementById(id);
 if (o)
 {
  var query = id + '=';
  if (o.type == "checkbox")
   query += (o.checked) ? '1' : '0';
  else
   query += encodeURIComponent(o.value);
  control_set(query);
 }
 else
  message_set("ctl", "Control '" + id + "' not found.", 4);
}
function ctl_reset(e, id)
{
 noprop(e);
 process_query('control.ctl?method=reset&' + id + "=0");
}

//** The page is now dead so make it look a bit dead..
function fuzzypage()
{
 var div = document.createElement('div');
 div.id = "dimScreen";
 document.body.appendChild(div);

 var table = document.getElementById("menu_table");
 if (table)
 {
  var cells = table.getElementsByTagName("td");
  for (var i=0; i<cells.length; i++)
  {
   cells[i].style.color = "gray";
   cells[i].style.background = "gray";
  }
 }
}

//** Jump to a new page
function jump_to_page(page, path)
{
 window.location.href = page + '?path=' + encodeURIComponent(path);
}

//** Page reload
function reloading()
{
 message_set("reload", "Reloading, please wait...", 10);
 ctl_setTimeout("location.reload(true);", 1500, "reload");
 fuzzypage();
}

//** Detect program restart
function ctl_restarted()
{
 process_query('misc.ctl?method=reload&starttime=' + ctl_starttime);
}

//** Program restarting..
function restarting()
{
 message_set("restart", "Restarting, please wait...", 10);
 setInterval("ctl_restarted()", 1000);
 fuzzypage();
}

function stopping()
{
 var msg = "Stopping web server...";
 message_set("stop", msg, 4);
 fuzzypage();
}

//** Add control to page
function controls_add(div_id, controls)
{
 control_list[control_list.length] = div_id + ':' + controls;
 control_list_cache = control_list.join(';');
}

function controls_load()
{
 process_query('control.ctl?method=layout');
}
function controls_load_help()
{
 process_query('control.ctl?method=layout&help=1');
}
function controls_load_div(div)
{
 var list = div.split(',');
 for (var i=0; i<list.length; i++)
  process_query('control.ctl?method=layout&div=' + list[i]);
}

function controls_del(div)
{

 var list = div.split(',');
 for (var i=0; i<list.length; i++)
 {

  var id  = list[i];
  var div = id + ':';
  for (var j=0; j<control_list.length; j++)
  {
   var entry = control_list[j];
   if (entry.indexOf(div) == 0)
    { control_list.splice(j, 1); break; }
  }
  set_inner_of(id, "");
 }
}

function is_child_of(child, paren)
{
 for (var i=0; i<paren.childNodes.length; i++)
 {
  if (paren.childNodes[i] == child)
   return true;
 }
 return false;
}

//** Set the size of a div when we populate it..
var div_vsize = [];
function ctl_vsize(id, ss)
{
 div_vsize[id] = ss;
}

//** Populate single control if present.
function ctl_pop(id, cid, because)
{
 var divid = cid + '.' + id;

 var query = 'control.ctl?method=pop&id=' + cid + '&divid=' + divid;
 var o = document.getElementById(divid);
 if (o)
 {
  var w = o.offsetWidth;
  var h = o.offsetHeight;

  var ss = div_vsize[divid];
  if (ss)
  {
   if (ss.indexOf('%') >= 0)
    h = (w * parseInt(ss)) / 100;
   else
    h = parseInt(ss);
  }
  query += "&w=" + w + "&h=" + h;
 }

 if (because)
  query+= '&because=' + because;
 process_query(query);
}

//** Set the page argument.
function set_pagearg(key, value)
{
 pageargs[key] = value;
}
function get_pagearg(key)
{
 var value = pageargs[key];
 return (value === undefined) ? null : value;
}

//** Set the post-only page argument.
function set_postarg(key, value)
{
 postargs[key] = value;
}

//** Fill id
function set_html_of(id, str, inner)
{
 var done = false;
 if (!str) str = '';
 var o = document.getElementById(id);
 if (o)
 {
  if (inner)
  {
   if (o.innerHTML != str)
   {
    o.innerHTML = str;
    done = true;
   }
  }
  else
  {
   if (o.outerHTML != str)
   {
    o.outerHTML = str;
    done = true;
   }
  }
 }

 return done;
}
function set_inner_of(id, str) { return set_html_of(id, str, true); }
function set_outer_of(id, str) { return set_html_of(id, str, false); }

function get_inner_of(id)
{
 var o = document.getElementById(id);
 return (o) ? o.innerHTML : null;
}

//** Expand a div to use the space left
function ctl_expand(container, used, expand, limit)
{
 var done = 0;
 var c = document.getElementById(container);
 var u = document.getElementById(used);
 var e = document.getElementById(expand);

 if (c && u && e)
 {
  var cw = c.offsetWidth;
  var uw = u.offsetWidth;
  var ew = e.offsetWidth;

  var et = cw - (uw - ew);
  if (et > ew)
  {
   if (limit && (et > limit)) et = limit;
   if (et > ew)
   {
    e.style.width = et;
    done = et;
   }
  }
 }
 return done;
}

//** Visible area size..
function viewport_wh(type)
{
 var e = window, a = 'inner';
 if (!('innerWidth' in window))
 {
  a = 'client';
  e = document.documentElement || document.body;
 }
 return e[a+type];
}

function viewport_width()  { return viewport_wh('Width'); }
function viewport_height() { return viewport_wh('Height'); }

//** Dropped off the bottom?
function ctl_find_gaps(id)
{
 var o = document.getElementById(id);
 if (o)
 {
  var top = o.offsetTop;
  var height = o.offsetHeight;
  var left = o.offsetLeft;
  var width = o.offsetWidth;

  while (o.offsetParent)
  {
   o = o.offsetParent;
   top  += o.offsetTop;
   left += o.offsetLeft;
  }

  var xgap = (window.pageXOffset + window.innerWidth)  - (left + width);
  var ygap = ( window.innerHeight) - (top + height);

  return Array(xgap, ygap);
 }

 return Array(0,0);
}

//** Is the item fixed on the screen?
function is_fixed(elm)
{
    var el;
    if (typeof elm === 'object')
  el = elm[0] || elm;
    else if (typeof elm === 'string')
  el = document.querySelector(elm);
    while (typeof el === 'object' && el.nodeName.toLowerCase() !== 'body')
 {
        if (window.getComputedStyle(el).getPropertyValue('position').toLowerCase() === 'fixed')
   return true;
        el = el.parentElement;
    }

    return false;
}

//** Get the LHS edge of the object
function ctl_pos_lhs(id)
{
 var lhs = 0;
 var o = document.getElementById(id);
 if (o)
 {
  var left  = o.offsetLeft;

  while (o.offsetParent)
  {
   o = o.offsetParent;
   left += o.offsetLeft;
  }

  lhs = left;
 }

 return lhs;
}

//** Get the RHS edge of the object
function ctl_pos_rhs(id)
{
 var rhs = 0;
 var o = document.getElementById(id);
 if (o)
 {
  var left  = o.offsetLeft;
  var width = o.offsetWidth;

  while (o.offsetParent)
  {
   o = o.offsetParent;
   left += o.offsetLeft;
  }

  rhs = left + width;
 }

 return rhs;
}

//** Y value of the page
function ctl_scroll_top()
{
    if (window.pageYOffset)
  return window.pageYOffset;
 else
  return Math.max(document.documentElement.scrollTop, document.body.scrollTop);
}

//** Get the Top edge of the object
function ctl_pos_top(id)
{
 var y = 0;
 var o = document.getElementById(id);
 if (o)
 {
  y  = o.offsetTop;

  while (o.offsetParent)
  {
   o = o.offsetParent;
   y += o.offsetTop;
  }
 }

 return y;
}

function what_browser()
{

 if (navigator.userAgent.indexOf(' Edge/') >= 0)
  return "Edge";
 else
 {
  var isOpera = !!window.opera || navigator.userAgent.indexOf(' OPR/') >= 0;
  var isFirefox = typeof InstallTrigger !== 'undefined';
  var isSafari = Object.prototype.toString.call(window.HTMLElement).indexOf('Constructor') > 0;
  var isChrome = !!window.chrome && !isOpera;
  var isIE = false || !!document.documentMode;

  var name = 'Unknown';
  if (isChrome)
   name = "Chrome";
  else if (isIE)
   name = "IE";
  else if (isSafari)
   name = "Safari";
  else if (isFirefox)
   name = "Firefox";
  else if (isOpera)
   name = "Opera";

  return name;
 }
}

//** IE version.
function what_IE()
{
 if (!document.all)
  return 11;
 else if (!document.querySelector)
  return 7;
 else if (!document.addEventListener)
  return 8;

 return 0;
}

function ctl_findclass(name)
{
 var rules = {};
 var ds=document.styleSheets;
 var dsl = ds.length;

 for (var i=0; i<dsl; i++)
 {
  var dsi = ds[i].cssRules;
  var dsil=dsi.length;
  for (var j=0; j<dsil; j++)
   rules[dsi[j].selectorText] = dsi[j];
 }

 if (rules.hasOwnProperty(name))
  return rules[name];
 else
  return null;
}

var message_array = [];
var message_id = 'id_message';
var message_utimer = null;
var message_null = true;

function message_update()
{

 if (message_utimer)
 {
  clearTimeout(message_utimer);
  message_utimer = null;
 }

 var len = message_array.length;
 if (len || !message_null)
 {
  var str = null;
  for (var i=len-1; i>=0; i--)
  {
   if (!str)
    str = message_array[i].string;
   else
    str += "<br>\n" + message_array[i].string;
  }

  message_null = str == null;

  set_inner_of(message_id, str);
  set_visible_of(message_id, str != null);

  message_utimer = ctl_setTimeout("message_update()", 1500, "mupdate");
 }
}

function message_expire(context)
{
 var len = message_array.length;
 for (var i=0; i<len; i++)
 {
  if (message_array[i].context == context)
  {
   message_array.splice(i, 1);
   message_update();
   break;
  }
 }
}

//** :
function message_set(context, string, life)
{
 var obj = null;

 var len = message_array.length;
 for (var i=0; i<len; i++)
 {
  if (message_array[i].context == context)
  {
   obj = message_array[i];
   break;
  }
 }

 if ((life <= 0) || !string)
 {
  if (obj)
  {
   clearTimeout(obj.timer);
   message_expire(obj.context);
  }
 }
 else
 {
  var update = false;

  if (obj)
  {
   clearTimeout(obj.timer);
   if (obj.string != string)
   {
    obj.string = string;
    update = true;
   }
  }
  else
  {
   obj = { context: context, string: string };
   message_array.push(obj);
   update = true;
  }

  var t = life * 1000;
  obj.timer = ctl_setTimeout("message_expire('"+obj.context+"')", t, "mexpire");

  if (update)
   message_update();
 }
}

function set_message(string, life)
{
 message_set("legacy", string, life);
}

function checksum(str)
{
 var sum = 0;

 for (var i=0; i<str.length; i++)
 {
  sum += ((sum << 5) - sum) + str.charCodeAt(i);
  sum |= 0;
 }
 if (sum < 0) sum = -sum;

 return sum;
}

function ctl_uploader(e, target, method, pic, id, fid)
{
 if (e)
  noprop(e);

 message_set("upload", "Uploading..", 20);

 var data = new FormData();

 data.append('id', id);
 data.append('lists', control_list_cache);

 for (var k in pageargs)
 {
     if (pageargs[k] && (typeof target[k] !== 'function'))
   data.append(k, pageargs[k]);
 }
 for (var k in postargs)
 {
     if (typeof target[k] !== 'function')
   data.append(k, postargs[k]);
 }

 var count = 0;

 if (fid)
 {
  var o = document.getElementById(fid);
  if (o && o.files)
  {
   for (var i=0; i<o.files.length; i++)
   {
    var file = o.files[i];

    var f = i + 1;
    data.append('file'+f, file, file.name);
    count++;
   }
  }
 }

 if (pic)
 {
  alert("Picture name = " + pic.name);
  data.append('file1', pic, pic.name);
  count++;
 }

 if (count)
 {

  data.append('method', method);

  ajax_request(target, data, process_query_reply, true);
 }
 else
  alert("Nothing found to upload");

 message_set("upload", null, 0);
}

//** Stop further onclick event propagation
function noprop(e)
{
 if (!e)
  e = window.event;
 if (e)
 {
  if (e.stopPropagation)
   e.stopPropagation();
  else
         e.cancelBubble = true;
 }
}

function stop_propagation(e) { noprop(e); }

//** Escape a string with single quotes for JS timeout callbacks, onclicks and evals.
function javastring(str)
{
 if (!str)
  return 'null';
 else
 {
  str = str.replace("'", "\\'");
  return "'" + str + "'";
 }
}

//** Escape a string with double quotes for HTML id, title etc..
function htmlstring(str)
{
 if (!str)
  return '"null"';
 else
 {
  str = str.replace('"', '&#34;');
  return '"' + str + '"';
 }
}

//** Is it completely on the scrolled page? Verticals only
function is_scrolled_in(id)
{
 var visible = false;
 var o = document.getElementById(id);
 if (o)
 {
     var rect = o.getBoundingClientRect();
  var elemTop = rect.top;
  var elemBottom = rect.bottom;
  var wbottom = window.innerHeight;

  visible = (elemTop >= 0) && (elemBottom <= wbottom);
 }

 return visible;
}

//** Is it partially or completely off the scrolled page? Verticals only
//** +1 if below, -1 if above!
function is_out_view_delta_o(o, delta)
{
 var invisible = 0;
 if (o)
 {

     var rect = o.getBoundingClientRect();

  if (rect.bottom < -delta)
   invisible = 1;
  else if (rect.top > (window.innerHeight + delta))
   invisible = -1;
 }

 return invisible;
}

//** Widen the viewport with delta
function is_out_view_o(o)
{
 return is_out_view_delta_o(o, 0);
}

//** Is it partially or completely on the scrolled page? Verticals only
function is_in_view_o(o)
{
 return is_out_view_o(o) == 0;
}

//** Is it partially or completely on the scrolled page? Verticals only
function is_in_view(id)
{
 if (id)
 {
  var o = document.getElementById(id);
  if (o)
   return is_in_view_o(o);
 }
 else
  return false;
}
var js_version = '4.7.1';

//** When the page loads various stuff may need to be done like aligning the menu, starting timers etc.
var ctl_onload_tasks = [];
var ctl_onload_waits = [];
function ctl_add_onload(str, ms)
{

 ctl_onload_waits.push(ms);
 ctl_onload_tasks.push(str);
}

function ctl_master_onload()
{
 for (var i=0; i<ctl_onload_waits.length; i++)
 {
  var ms = ctl_onload_waits[i];
  if (ms <= 0)
   ms = 1;
  var task = ctl_onload_tasks[i];
  ctl_setTimeout(task, ms, "onload");
 }
}

var fctl_sleepy_init  = false;
var fctl_page_visible = true;
var fctl_sleepy_notify  = null;

function ctl_sleepy_timeout_int(target, ms_orig, ms_sleepy, acc)
{

 if (fctl_page_visible)
 {
  var ms = ms_orig - acc;
  if (ms < 1) ms = 1;
  setTimeout(target, ms);
 }
 else
 {
  var max = 750;
  ms_sleepy -= max;
  if (ms_sleepy <= 1)
   setTimeout(target, 1);
  else
  {
   acc += max;
   var later = "ctl_sleepy_timeout_int('" + target + "'," + ms_orig + "," + ms_sleepy  + "," + acc +  ")";
   setTimeout(later, max);
  }
 }
}

function ctl_sleepyTimeout(target, ms, notify)
{
 fctl_sleepy_notify = notify;

 if (!fctl_sleepy_init)
 {

  fctl_sleepy_init = true;
  fctl_page_visible = document.visibilityState === 'visible';

  document.addEventListener("visibilitychange", function() {
   fctl_page_visible = document.visibilityState === 'visible';
   if (fctl_sleepy_notify)
   {
    if (fctl_page_visible)
     setTimeout(fctl_sleepy_notify + "(true)", 1500);
    else
     setTimeout(fctl_sleepy_notify + "(false)", 1);
   }
  });
 }

 ctl_sleepy_timeout_int(target, ms, 20000, 0);
}

function ctl_control_by_name(cname)
{
 var controls = document.getElementsByName(cname);
 if (controls)
  return controls[0];
 else
  return null;
}

function ctl_selected_obj(sel)
{
 return (sel) ? sel.options[sel.selectedIndex] : null;
}

function ctl_selected_option(cname)
{
 var sel = ctl_control_by_name(cname);
 return ctl_selected_obj(sel);
}

function ctl_select_chosen_value(cname)
{
 var option = ctl_selected_option(cname);
 return (option) ? option.value : null;
}

function ctl_select_chosen_text(cname)
{
 var option = ctl_selected_option(cname);
 return (option) ? option.text : null;
}

function ctl_checkbox_value(cname)
{
 var cbox = ctl_control_by_name(cname);
 return (cbox) ? cbox.checked : false;
}

var js_version = '4.7.1';
